#extension GL_OES_EGL_image_external : require
precision highp float;

//varying vec2 v_TextureCoord;
varying vec2 vTextureCoord;
//uniform sampler2D s_Texture;
uniform samplerExternalOES sTexture;
uniform vec2 u_TextureSize;
uniform float thresholdL;
uniform float thresholdH;
uniform vec3 color;

#define AVG(__rgb) (__rgb.r + __rgb.g + __rgb.b)/3.0

void main() {
    //vec2 uv = gl_FragCoord.xy / u_TextureSize;
    //vec2 uv = v_TextureCoord;
    vec2 uv = vTextureCoord;
    //vec2 d = 1.0 / u_TextureSize;
    //vec2 d = vec2(1.0/1920.0, 1.0/1080.0);
    vec2 d = 1.0 / vec2(1920.0, 1080.0);

    vec4 h = (
         -1.0 * texture2D(sTexture, uv + vec2(-d.x, -d.y)) +
         -2.0 * texture2D(sTexture, uv + vec2(-d.x,  0.0)) +
         -1.0 * texture2D(sTexture, uv + vec2(-d.x,  d.y)) +
         +1.0 * texture2D(sTexture, uv + vec2( d.x, -d.y)) +
         +2.0 * texture2D(sTexture, uv + vec2( d.x,  0.0)) +
         +1.0 * texture2D(sTexture, uv + vec2( d.x,  d.y))
    );

    vec4 v = (
         -1.0 * texture2D(sTexture, uv + vec2(-d.x, -d.y)) +
         -2.0 * texture2D(sTexture, uv + vec2( 0.0, -d.y)) +
         -1.0 * texture2D(sTexture, uv + vec2( d.x, -d.y)) +
         +1.0 * texture2D(sTexture, uv + vec2(-d.x,  d.y)) +
         +2.0 * texture2D(sTexture, uv + vec2( 0.0,  d.y)) +
         +1.0 * texture2D(sTexture, uv + vec2( d.x,  d.y))
    );

    float sobel = length(vec2(AVG(h), AVG(v)));
    //sobel = smoothstep(thresholdL, thresholdH, sobel);
    sobel = smoothstep(0.3, 0.8, sobel);
    //vec3 c = vec3(sobel, sobel, sobel) * color;
    vec3 c = vec3(sobel, sobel, sobel) * vec3(0.0,1.0,0.0);

    gl_FragColor = vec4(c, 1.0);
}